#include <tamtypes.h>
#include <string.h>
#include <kernel.h>
#include <fileio.h>
#include <sifrpc.h>
#include <loadfile.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <libpad.h>

#include "includeSdl.h"

#include "main.h"
#include "video.h"
#include "input.h"

#include "net.h"

#include "../../emu/h/types.h"
#include "../../nes/h/nes.h"
#include "../../emu/h/emuPalette.h"
#include "../../emu/h/emuFileHandling.h"

extern "C"
{
#include "hw.h"
#include "gs.h"
#include "gfxpipe.h"
#include "sjpcm.h"
extern int init_machine();
}

#define SCREEN_W 320
#define SCREEN_H 256
#define NWIDTH SCREEN_W
#define NHEIGHT SCREEN_H
#define TXTMIN 0
#define TXTMAX 320
#define NES_TEX		0x0A0000 + 0x0A0000
#define VRAM_MAX	0x3E8000
int dispx, dispy;
int whichdrawbuf = 0;

u32 bmp[ 256 * 256 ] __attribute__((aligned(64))) __attribute__ ((section (".bss")));

int appInit()
{
	if (initMemory())
		return 10;

	if (nesInit())
		return 11;

	//if (initSound())
	//	return 12;

printf("ok\n");
/*	if (initNet())
		return 13;
*/
	//loadDefaultKeys();
	return 0;
}

void appDestory(void)
{
//	cleanNet();
	nesClean();
	uninitSound();
	uninitMemory();
	destoryPalette();
}

void InfoNES_LoadFrame()
{ 
  
    gp_uploadTexture(&thegp, NES_TEX, 256, 0, 0, 0x02,&bmp, 256, 240);
    gp_setTex(&thegp, NES_TEX, 256, 8, 8, 0x02, 0, 0, 0,0);

    gp_texrect(&thegp, 0<<4,0<<4, 0<<4, 0<<4, (256)<<4, (240)<<4, 256<<4, 240<<4, 2, GS_SET_RGBA(255, 255, 255, 128));
     
	gp_hardflush(&thegp);

	WaitForNextVRstart(1);

	// Update drawing and display enviroments.
    GS_SetCrtFB(whichdrawbuf);
    whichdrawbuf ^= 1;
    GS_SetDrawFB(whichdrawbuf);

}

int main(int argc, char *argv[])
{
	int bad;
	if (bad = appInit())
	{
		printf("Error #%d, You seen the msg", bad);
		//SDL_Delay(2000);
		return 20;
	}
printf("\n%s\n",argv[1]);
	if (argc != 2 )
		bad = 1;
	else
	{
		unsigned int i;
		for (i = strlen(argv[1]) - 3; i < strlen(argv[1]); i++)
			argv[1][i] |= 0x20;	//lower case it
		
		bad = strcmp( &argv[1][i-4], ".nes");
	}
	if (bad)
	{
		int i;
		printf("You must drag and drop 1 file (or is not a .nes file)\n");
		for (i=0; i < argc; i++)
		{
			printf( argv[i] );
			printf("\n");
		}
		if (argc > 1)
			printf( &argv[1][ strlen(argv[1]) - 4 ] );

		//SDL_Delay(2000);
		return 0;
	}

	SetLocalPath(argv[0]);

    //ps2init
    init_machine();

	  screen= new u32[256*256];
	  screen  = (unsigned *)&bmp[0];

		u8 ScreenDepth =16;
		if (ScreenDepth == 16)
			initPalette15();
		/*else if (ScreenDepth == 24)
			initPalette24();*/	
		else if (ScreenDepth == 32)
			initPalette32();
		else
		{
			emuMsg("Invalid screen depth");
			return 5;		//unknown screen depth
		}
	

//	SDL_WM_SetCaption(wndName, 0);	
	sprintf(	szFilename,"host:%s",argv[1]);	 

	loadPath();
//	hehNet(); 
	mainLoop();
	return 0;  
}
