#include <tamtypes.h>
#include <string.h>
#include <kernel.h>
#include <fileio.h>
#include <sifrpc.h>
#include <loadfile.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <libpad.h>

#include "hw.h"
#include "gs.h"
#include "gfxpipe.h"
#include "sjpcm.h"

#include "sbv_patches.h"
#include <libmc.h>

#define SCREEN_W 320
#define SCREEN_H 256
#define NWIDTH SCREEN_W
#define NHEIGHT SCREEN_H

//extern u8 *libcdvd_irx;		
//extern int size_libcdvd_irx;

extern u8 *sjpcm_irx;		
extern int size_sjpcm_irx;	

 int dispx, dispy;
 int sound ;
 int snd_sample;
 int snd_sampler;
 short signed int *tmpsnd;
extern unsigned/* long*/  dwKeyPad1;
extern unsigned/* long*/  dwKeyPad2;
//extern unsigned long  dwKeySystem;
//extern unsigned short NesPalette[ 64 ];

#define FALSE 0
#define TRUE 1
#define display_error printf
#define sceSifInitRpc SifInitRpc


 int bThread;

void LoadModules(void)
{
    int ret;
   
	ret = SifLoadModule("rom0:SIO2MAN", 0, NULL);
	if (ret < 0) {
			printf("Failed to load module: SIO2MAN");
    }
   
	ret = SifLoadModule("rom0:MCMAN", 0, NULL);
	if (ret < 0) {
			printf("Failed to load module: MCMAN");
    }
	ret = SifLoadModule("rom0:MCSERV", 0, NULL);
	if (ret < 0) {
			printf("Failed to load module: MCSERV");
    }
      
	ret = SifLoadModule("rom0:PADMAN", 0, NULL);
	if (ret < 0) {
			printf("Failed to load module: PADMAN");
    } 
    
    ret = SifLoadModule("rom0:LIBSD", 0, NULL);
	if (ret < 0) {
			printf("Failed to load module: LIBSD");
    }
    
    SifExecModuleBuffer(&sjpcm_irx, size_sjpcm_irx,0, NULL, &ret);
	if (ret < 0)
	{
			display_error("Failed to load module: SJPCM.IRX :(", 1);    
	}
   
    /*
    SifExecModuleBuffer(&libcdvd_irx, size_libcdvd_irx,0, NULL, &ret);
	if (ret < 0)
	{
			display_error("Failed to load module: LIBCDVD.IRX :(", 1);    
	}*/
}

int gsinit()
{
	DmaReset();
	
	if(pal_ntsc() == 3) {
		GS_InitGraph(GS_PAL,GS_NONINTERLACE);
		dispx =75;//40;//65
		dispy = 40;
		GS_SetDispMode(dispx,dispy,NWIDTH,NHEIGHT);
		snd_sampler = 48000 / 50;
	} else {
		GS_InitGraph(GS_NTSC,GS_NONINTERLACE);
		dispx = 65;
		dispy = 17;
		GS_SetDispMode(dispx,dispy,NWIDTH,NHEIGHT);
		snd_sampler = 48000 / 60;
	}
 
	GS_SetEnv(NWIDTH, NHEIGHT, 0, 0x50000, GS_PSMCT32, 0xA0000, GS_PSMZ16S);
	
    install_VRstart_handler();
     
	createGfxPipe(&thegp, /*(void *)0xF00000,*/ 0x50000);
	
	gp_hardflush(&thegp);
	
	 return 0;
}


int init_machine(void)
{
 int    r,g,b,i;
 
    SifInitRpc(0); 
     
	sbv_patch_enable_lmb();			// not sure we really need to do this again
	sbv_patch_disable_prefix_check();	// here, but will it do any harm?
	
	LoadModules();  
 	
    gsinit();
   
    tmpsnd=malloc(sizeof(short signed int )*snd_sampler);
   // tmpsnd[1]=malloc(sizeof(short signed int )*snd_sampler);  
    for(i=0;i<snd_sampler;i++)tmpsnd[i]=0;
     
    setup_pad();    
    
	if(sound)if(SjPCM_Init(1) < 0)printf("SjPCM Bind failed!!");
 
  /* Initialize a pad state */
  dwKeyPad1   = 0;
  dwKeyPad2   = 0;

  /* Initialize thread state */
  bThread = FALSE;
 

    return (1);
}

